package encryptionproject;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

class EncryptionCaesarMethod extends EncryptionMethod
    implements ActionListener
{

    public EncryptionCaesarMethod()
    {
    }

    private void setKey()
    {
        lblLetters.setText("A B C D E F G H I J K L M N O P Q R S T U V W X Y Z");
        String s = "";
        for(int i = 0; i < 26; i++)
        {
            int j = 65 + i + iKey;
            if(j > 90)
                j = ((j - 90) + 65) - 1;
            s = s + (char)j + " ";
        }

        lblMapping.setText(s);
        txtKey.setText("" + iKey);
    }

    public String encrypt(String s, TutorialDisplay tutorialdisplay)
    {
        int k;
        try
        {
            k = (new Integer(txtKey.getText())).intValue();
        }
        catch(NumberFormatException numberformatexception)
        {
            k = -1;
        }
        String s1 = "";
        if(k > -1 && k < 26)
        {
            tutorialdisplay.addText("\n===============\nCaesar Cipher using shift " + k + "\n\n");
            s = s.toUpperCase();
            for(int i = 0; i < s.length(); i++)
                if(Character.isLetter(s.charAt(i)))
                {
                    int j = s.charAt(i);
                    j += k;
                    if(j > 90)
                        j = ((j - 90) + 65) - 1;
                    s1 = s1 + (char)j;
                    tutorialdisplay.addText(s.charAt(i) + " -> " + (char)j + "\n");
                } else
                {
                    switch(s.charAt(i))
                    {
                    case 32: // ' '
                        s1 = s1 + " ";
                        break;

                    case 10: // '\n'
                        s1 = s1 + "\n";
                        break;

                    default:
                        s1 = s1 + "-";
                        break;
                    }
                }

        } else
        {
            s1 = "Invalid Key: Key must be an integer between 1 and 25";
        }
        return s1;
    }

    public Panel getOptionsPanel()
    {
        Panel panel = new Panel(new BorderLayout());
        Panel panel1 = new Panel();
        butDecr = new Button("<<");
        butDecr.addActionListener(this);
        panel1.add(butDecr);
        panel1.add(new Label("Shift:"));
        txtKey = new TextField(5);
        txtKey.setBackground(Color.white);
        txtKey.setEditable(false);
        panel1.add(txtKey);
        butIncr = new Button(">>");
        butIncr.addActionListener(this);
        panel1.add(butIncr);
        panel.add(panel1, "Center");
        panel.setBackground(Color.cyan);
        panel1 = new Panel(new GridLayout(2, 1));
        lblLetters = new Label();
        lblLetters.setFont(EncryptionProject.MONOSPACE_FONT);
        lblMapping = new Label();
        lblMapping.setFont(EncryptionProject.MONOSPACE_FONT);
        panel1.add(lblLetters);
        panel1.add(lblMapping);
        Panel panel2 = new Panel();
        panel2.add(panel1);
        panel.add(panel2, "South");
        iKey = 1;
        setKey();
        return panel;
    }

    public void actionPerformed(ActionEvent actionevent)
    {
        String s = actionevent.getActionCommand();
        if(s.equals(">>"))
        {
            iKey++;
            if(iKey > 25)
                iKey = 0;
            setKey();
        } else
        if(s.equals("<<"))
        {
            iKey--;
            if(iKey < 0)
                iKey = 25;
            setKey();
        }
    }

    public static final String BUTINCR_LABEL = ">>";
    public static final String BUTDECR_LABEL = "<<";
    private Button butIncr;
    private Button butDecr;
    private TextField txtKey;
    private Label lblLetters;
    private Label lblMapping;
    private int iKey;
}
