package encryptionproject;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.PrintStream;

class EncryptionDESMethod extends EncryptionMethod
    implements ActionListener
{

    public EncryptionDESMethod()
    {
    }

    public String encrypt(String s, TutorialDisplay tutorialdisplay)
    {
        int ai2[] = {
            57, 49, 41, 33, 25, 17, 9, 1, 58, 50, 
            42, 34, 26, 18, 10, 2, 59, 51, 43, 35, 
            27, 19, 11, 3, 60, 52, 44, 36, 63, 55, 
            47, 39, 31, 23, 15, 7, 62, 54, 46, 38, 
            30, 22, 14, 6, 61, 53, 45, 37, 29, 21, 
            13, 5, 28, 20, 12, 4
        };
        int ai3[] = {
            14, 17, 11, 24, 1, 5, 3, 28, 15, 6, 
            21, 10, 23, 19, 12, 4, 26, 8, 16, 7, 
            27, 20, 13, 2, 41, 52, 31, 37, 47, 55, 
            30, 40, 51, 45, 33, 48, 44, 49, 39, 56, 
            34, 53, 46, 42, 50, 36, 29, 32
        };
        txt = tutorialdisplay;
        String s2 = choiceKey01.getSelectedItem() + choiceKey02.getSelectedItem() + choiceKey03.getSelectedItem() + choiceKey04.getSelectedItem() + choiceKey05.getSelectedItem() + choiceKey06.getSelectedItem() + choiceKey07.getSelectedItem() + choiceKey08.getSelectedItem();
        txt.addText("\n===============\nDES Encryption using key: " + s2 + "\n\n");
        int ai[] = new int[64];
        convertBinaryKey(s2, ai);
        txt.addText("Binary key is " + getArrayString(ai) + " (every 8th bit is dropped)\n");
        int ai1[] = new int[56];
        txt.addText("Permuting key by the following matrix:\n" + getMatrixString(ai2, 7) + "\n");
        permuteKey(ai, ai1, ai2);
        txt.addText("Permuted key is " + getArrayString(ai1) + "\n");
        int ai4[][] = new int[17][28];
        int ai5[][] = new int[17][28];
        shiftPermutedKeys(ai1, ai4, ai5);
        txt.addText("\nSplitting key \n" + getArrayString(ai4[0]) + "\n" + getArrayString(ai5[0]) + "\n");
        txt.addText("\nCreating 16 Subkeys\n");
        txt.addText("Left shifting split keys\n");
        txt.addText("Key 1, 1 left shift:\n" + getArrayString(ai4[1]) + "\n" + getArrayString(ai5[1]) + "\n");
        txt.addText("Key 2, 1 left shift:\n" + getArrayString(ai4[2]) + "\n" + getArrayString(ai5[2]) + "\n");
        txt.addText("Key 3, 2 left shifts:\n" + getArrayString(ai4[3]) + "\n" + getArrayString(ai5[3]) + "\n");
        txt.addText("Key 4, 2 left shifts:\n" + getArrayString(ai4[4]) + "\n" + getArrayString(ai5[4]) + "\n");
        txt.addText("Key 5, 2 left shifts:\n" + getArrayString(ai4[5]) + "\n" + getArrayString(ai5[5]) + "\n");
        txt.addText("Key 6, 2 left shifts:\n" + getArrayString(ai4[6]) + "\n" + getArrayString(ai5[6]) + "\n");
        txt.addText("Key 7, 2 left shifts:\n" + getArrayString(ai4[7]) + "\n" + getArrayString(ai5[7]) + "\n");
        txt.addText("Key 8, 2 left shifts:\n" + getArrayString(ai4[8]) + "\n" + getArrayString(ai5[8]) + "\n");
        txt.addText("Key 9, 1 left shift:\n" + getArrayString(ai4[9]) + "\n" + getArrayString(ai5[9]) + "\n");
        txt.addText("Key 10, 2 left shifts:\n" + getArrayString(ai4[10]) + "\n" + getArrayString(ai5[10]) + "\n");
        txt.addText("Key 11, 2 left shifts:\n" + getArrayString(ai4[11]) + "\n" + getArrayString(ai5[11]) + "\n");
        txt.addText("Key 12, 2 left shifts:\n" + getArrayString(ai4[12]) + "\n" + getArrayString(ai5[12]) + "\n");
        txt.addText("Key 13, 2 left shifts:\n" + getArrayString(ai4[13]) + "\n" + getArrayString(ai5[13]) + "\n");
        txt.addText("Key 14, 2 left shifts:\n" + getArrayString(ai4[14]) + "\n" + getArrayString(ai5[14]) + "\n");
        txt.addText("Key 15, 2 left shifts:\n" + getArrayString(ai4[15]) + "\n" + getArrayString(ai5[15]) + "\n");
        txt.addText("Key 16, 1 left shift:\n" + getArrayString(ai4[16]) + "\n" + getArrayString(ai5[16]) + "\n");
        int ai6[][] = new int[16][48];
        int ai7[] = new int[56];
        txt.addText("\nReforming split keys to create subkeys\n");
        for(int i = 0; i < 16; i++)
        {
            System.arraycopy(ai4[i + 1], 0, ai7, 0, 28);
            System.arraycopy(ai5[i + 1], 0, ai7, 28, 28);
            txt.addText("Key " + (i + 1) + ": " + getArrayString(ai7) + "\n");
            permuteKey(ai7, ai6[i], ai3);
        }

        txt.addText("\nPermuting subkeys by the following matrix\n" + getMatrixString(ai3, 6) + "\n");
        for(int j = 0; j < 16; j++)
            txt.addText("Key " + (j + 1) + ":\n" + getArrayString(ai6[j]) + "\n");

        int k = 0;
        String s1 = "";
        for(; k < s.length(); k += 8)
        {
            txt.addText("\n\nEncrypting Message\n");
            int ai8[] = new int[64];
            convertMessage(s.substring(k), ai8);
            txt.addText("\n64 Bit message block is " + getArrayString(ai8) + "\n");
            s1 = s1 + encodeMessage(ai8, ai6);
        }

        return s1;
    }

    private String encodeMessage(int ai[], int ai1[][])
    {
        int ai3[] = {
            58, 50, 42, 34, 26, 18, 10, 2, 60, 52, 
            44, 36, 28, 20, 12, 4, 62, 54, 46, 38, 
            30, 22, 14, 6, 64, 56, 48, 40, 32, 24, 
            16, 8, 57, 49, 41, 33, 25, 17, 9, 1, 
            59, 51, 43, 35, 27, 19, 11, 3, 61, 53, 
            45, 37, 29, 21, 13, 5, 63, 55, 47, 39, 
            31, 23, 15, 7
        };
        int ai4[] = {
            32, 1, 2, 3, 4, 5, 4, 5, 6, 7, 
            8, 9, 8, 9, 10, 11, 12, 13, 12, 13, 
            14, 15, 16, 17, 16, 17, 18, 19, 20, 21, 
            20, 21, 22, 23, 24, 25, 24, 25, 26, 27, 
            28, 29, 28, 29, 30, 31, 32, 1
        };
        int ai5[] = {
            16, 7, 20, 21, 29, 12, 28, 17, 1, 15, 
            23, 26, 5, 18, 31, 10, 2, 8, 24, 14, 
            32, 27, 3, 9, 19, 13, 30, 6, 22, 11, 
            4, 25
        };
        int ai12[] = {
            40, 8, 48, 16, 56, 24, 64, 32, 39, 7, 
            47, 15, 55, 23, 63, 31, 38, 6, 46, 14, 
            54, 22, 62, 30, 37, 5, 45, 13, 53, 21, 
            61, 29, 36, 4, 44, 12, 52, 20, 60, 28, 
            35, 3, 43, 11, 51, 19, 59, 27, 34, 2, 
            42, 10, 50, 18, 58, 26, 33, 1, 41, 9, 
            49, 17, 57, 25
        };
        int ai2[] = new int[64];
        permuteKey(ai, ai2, ai3);
        txt.addText("Initial Permutation Table:\n" + getMatrixString(ai3, 4));
        txt.addText("E-Bit Selection Table:\n" + getMatrixString(ai4, 6));
        txt.addText("P Table:\n" + getMatrixString(ai5, 4));
        txt.addText("Final Permutation Table:\n" + getMatrixString(ai12, 4));
        txt.addText("\nPermuting message by Initial Permutation Table\n");
        txt.addText("\nPermuted message is " + getArrayString(ai2) + "\n");
        int ai6[][] = new int[17][32];
        int ai7[][] = new int[17][32];
        txt.addText("Splitting Message into L0, R0\n");
        for(int i = 0; i < 32; i++)
        {
            ai6[0][i] = ai2[i];
            ai7[0][i] = ai2[i + 32];
        }

        for(int j = 0; j < 16; j++)
        {
            txt.addText("\nCopying R" + j + " to L" + (j + 1) + "\n" + getArrayString(ai7[j]) + "\n");
            System.arraycopy(ai7[j], 0, ai6[j + 1], 0, 32);
            int ai8[] = new int[48];
            permuteKey(ai7[j], ai8, ai4);
            txt.addText("Permuted R" + j + " by E-Bit Selection Table\n" + getArrayString(ai8) + "\n");
            int ai9[] = new int[48];
            computeXOR(ai8, ai1[j], ai9);
            txt.addText("Calculating R" + j + " XOR (Key " + (j + 1) + "), Result:\n" + getArrayString(ai9) + "\n");
            int ai10[] = new int[32];
            for(int l = 1; l < 9; l++)
            {
                txt.addText("Using table S" + l + " ");
                getSValue(ai9, ai10, l);
            }

            txt.addText("Resulting message after S Table lookups\n" + getArrayString(ai10) + "\n");
            int ai11[] = new int[32];
            permuteKey(ai10, ai11, ai5);
            txt.addText("Permuting message by P Table, Result:\n" + getArrayString(ai10) + "\n");
            computeXOR(ai6[j], ai11, ai7[j + 1]);
            txt.addText("Computing L" + j + " XOR R" + j + " and storing result in R" + (j + 1) + ":\n" + getArrayString(ai7[j + 1]) + "\n");
        }

        int ai13[] = new int[64];
        System.arraycopy(ai7[16], 0, ai13, 0, 32);
        System.arraycopy(ai6[16], 0, ai13, 32, 32);
        txt.addText("Resulting conctenated encoded message:\n" + getArrayString(ai13) + "\n");
        int ai14[] = new int[64];
        permuteKey(ai13, ai14, ai12);
        txt.addText("Permuting message by Final Permutation Table, Result:\n" + getArrayString(ai14) + "\n");
        String s = "";
        for(int k = 0; k < 8; k++)
        {
            int i1 = ai14[k * 8 + 0] * 128 + ai14[k * 8 + 1] * 64 + ai14[k * 8 + 2] * 32 + ai14[k * 8 + 3] * 16 + ai14[k * 8 + 4] * 8 + ai14[k * 8 + 5] * 4 + ai14[k * 8 + 6] * 2 + ai14[k * 8 + 7] * 1;
            s = s + (char)i1;
        }

        return s;
    }

    private void getSValue(int ai[], int ai1[], int i)
    {
        int ai2[][] = {
            {
                14, 4, 13, 1, 2, 15, 11, 8, 3, 10, 
                6, 12, 5, 9, 0, 7
            }, {
                0, 15, 7, 4, 14, 2, 13, 1, 10, 6, 
                12, 11, 9, 5, 3, 8
            }, {
                4, 1, 14, 8, 13, 6, 2, 11, 15, 12, 
                9, 7, 3, 10, 5, 0
            }, {
                15, 12, 8, 2, 4, 9, 1, 7, 5, 11, 
                3, 14, 10, 0, 6, 13
            }
        };
        int ai3[][] = {
            {
                15, 1, 8, 14, 6, 11, 3, 4, 9, 7, 
                2, 13, 12, 0, 5, 10
            }, {
                3, 13, 4, 7, 15, 2, 8, 14, 12, 0, 
                1, 10, 6, 9, 11, 5
            }, {
                0, 14, 7, 11, 10, 4, 13, 1, 5, 8, 
                12, 6, 9, 3, 2, 15
            }, {
                13, 8, 10, 1, 3, 15, 4, 2, 11, 6, 
                7, 12, 0, 5, 14, 9
            }
        };
        int ai4[][] = {
            {
                10, 0, 9, 14, 6, 3, 15, 5, 1, 13, 
                12, 7, 11, 4, 2, 8
            }, {
                13, 7, 0, 9, 3, 4, 6, 10, 2, 8, 
                5, 14, 12, 11, 15, 1
            }, {
                13, 6, 4, 9, 8, 15, 3, 0, 11, 1, 
                2, 12, 5, 10, 14, 7
            }, {
                1, 10, 13, 0, 6, 9, 8, 7, 4, 15, 
                14, 3, 11, 5, 2, 12
            }
        };
        int ai5[][] = {
            {
                7, 13, 14, 3, 0, 6, 9, 10, 1, 2, 
                8, 5, 11, 12, 4, 15
            }, {
                13, 8, 11, 5, 6, 15, 0, 3, 4, 7, 
                2, 12, 1, 10, 14, 9
            }, {
                10, 6, 9, 0, 12, 11, 7, 13, 15, 1, 
                3, 14, 5, 2, 8, 4
            }, {
                3, 15, 0, 6, 10, 1, 13, 8, 9, 4, 
                5, 11, 12, 7, 2, 14
            }
        };
        int ai6[][] = {
            {
                2, 12, 4, 1, 7, 10, 11, 6, 8, 5, 
                3, 15, 13, 0, 14, 9
            }, {
                14, 11, 2, 12, 4, 7, 13, 1, 5, 0, 
                15, 10, 3, 9, 8, 6
            }, {
                4, 2, 1, 11, 10, 13, 7, 8, 15, 9, 
                12, 5, 6, 3, 0, 14
            }, {
                11, 8, 12, 7, 1, 14, 2, 13, 6, 15, 
                0, 9, 10, 4, 5, 3
            }
        };
        int ai7[][] = {
            {
                12, 1, 10, 15, 9, 2, 6, 8, 0, 13, 
                3, 4, 14, 7, 5, 11
            }, {
                10, 15, 4, 2, 7, 12, 9, 5, 6, 1, 
                13, 14, 0, 11, 3, 8
            }, {
                9, 14, 15, 5, 2, 8, 12, 3, 7, 0, 
                4, 10, 1, 13, 11, 6
            }, {
                4, 3, 2, 12, 9, 5, 15, 10, 11, 14, 
                1, 7, 6, 0, 8, 13
            }
        };
        int ai8[][] = {
            {
                4, 11, 2, 14, 15, 0, 8, 13, 3, 12, 
                9, 7, 5, 10, 6, 1
            }, {
                13, 0, 11, 7, 4, 9, 1, 10, 14, 3, 
                5, 12, 2, 15, 8, 6
            }, {
                1, 4, 11, 13, 12, 3, 7, 14, 10, 15, 
                6, 8, 0, 5, 9, 2
            }, {
                6, 11, 13, 8, 1, 4, 10, 7, 9, 5, 
                0, 15, 14, 2, 3, 12
            }
        };
        int ai9[][] = {
            {
                13, 2, 8, 4, 6, 15, 11, 1, 10, 9, 
                3, 14, 5, 0, 12, 7
            }, {
                1, 15, 13, 8, 10, 3, 7, 4, 12, 5, 
                6, 11, 0, 14, 9, 2
            }, {
                7, 11, 4, 1, 9, 12, 14, 2, 0, 6, 
                10, 13, 15, 3, 5, 8
            }, {
                2, 1, 14, 7, 4, 10, 8, 13, 15, 12, 
                9, 0, 3, 5, 6, 11
            }
        };
        int i1 = (i - 1) * 6;
        int j = ai[0 + i1] * 2 + ai[5 + i1] * 1;
        int k = ai[1 + i1] * 8 + ai[2 + i1] * 4 + ai[3 + i1] * 2 + ai[4 + i1] * 1;
        int l;
        switch(i)
        {
        case 1: // '\001'
            l = ai2[j][k];
            break;

        case 2: // '\002'
            l = ai3[j][k];
            break;

        case 3: // '\003'
            l = ai4[j][k];
            break;

        case 4: // '\004'
            l = ai5[j][k];
            break;

        case 5: // '\005'
            l = ai6[j][k];
            break;

        case 6: // '\006'
            l = ai7[j][k];
            break;

        case 7: // '\007'
            l = ai8[j][k];
            break;

        case 8: // '\b'
            l = ai9[j][k];
            break;

        default:
            l = 0;
            break;
        }
        i1 = (i - 1) * 4;
        ai1[0 + i1] = l / 8;
        ai1[1 + i1] = (l % 8) / 4;
        ai1[2 + i1] = (l % 8 % 4) / 2;
        ai1[3 + i1] = (l % 8 % 4 % 2) / 1;
        txt.addText("Result: " + l + "\n");
    }

    private void computeXOR(int ai[], int ai1[], int ai2[])
    {
        for(int i = 0; i < ai.length; i++)
            if(ai[i] + ai1[i] == 1)
                ai2[i] = 1;
            else
                ai2[i] = 0;

    }

    private void convertMessage(String s, int ai[])
    {
        for(int i = 0; i < 8; i++)
        {
            char c;
            if(s.length() - 1 < i)
                c = '\0';
            else
                c = s.charAt(i);
            ai[i * 8 + 0] = c / 128;
            ai[i * 8 + 1] = (c % 128) / 64;
            ai[i * 8 + 2] = (c % 64) / 32;
            ai[i * 8 + 3] = (c % 32) / 16;
            ai[i * 8 + 4] = (c % 16) / 8;
            ai[i * 8 + 5] = (c % 8) / 4;
            ai[i * 8 + 6] = (c % 4) / 2;
            ai[i * 8 + 7] = (c % 2) / 1;
        }

    }

    private void convertBinaryKey(String s, int ai[])
    {
        for(int i = 0; i < 16; i++)
        {
            int j = i * 4;
            switch(s.charAt(i))
            {
            case 48: // '0'
                ai[j + 0] = 0;
                ai[j + 1] = 0;
                ai[j + 2] = 0;
                ai[j + 3] = 0;
                break;

            case 49: // '1'
                ai[j + 0] = 0;
                ai[j + 1] = 0;
                ai[j + 2] = 0;
                ai[j + 3] = 1;
                break;

            case 50: // '2'
                ai[j + 0] = 0;
                ai[j + 1] = 0;
                ai[j + 2] = 1;
                ai[j + 3] = 0;
                break;

            case 51: // '3'
                ai[j + 0] = 0;
                ai[j + 1] = 0;
                ai[j + 2] = 1;
                ai[j + 3] = 1;
                break;

            case 52: // '4'
                ai[j + 0] = 0;
                ai[j + 1] = 1;
                ai[j + 2] = 0;
                ai[j + 3] = 0;
                break;

            case 53: // '5'
                ai[j + 0] = 0;
                ai[j + 1] = 1;
                ai[j + 2] = 0;
                ai[j + 3] = 1;
                break;

            case 54: // '6'
                ai[j + 0] = 0;
                ai[j + 1] = 1;
                ai[j + 2] = 1;
                ai[j + 3] = 0;
                break;

            case 55: // '7'
                ai[j + 0] = 0;
                ai[j + 1] = 1;
                ai[j + 2] = 1;
                ai[j + 3] = 1;
                break;

            case 56: // '8'
                ai[j + 0] = 1;
                ai[j + 1] = 0;
                ai[j + 2] = 0;
                ai[j + 3] = 0;
                break;

            case 57: // '9'
                ai[j + 0] = 1;
                ai[j + 1] = 0;
                ai[j + 2] = 0;
                ai[j + 3] = 1;
                break;

            case 65: // 'A'
                ai[j + 0] = 1;
                ai[j + 1] = 0;
                ai[j + 2] = 1;
                ai[j + 3] = 0;
                break;

            case 66: // 'B'
                ai[j + 0] = 1;
                ai[j + 1] = 0;
                ai[j + 2] = 1;
                ai[j + 3] = 1;
                break;

            case 67: // 'C'
                ai[j + 0] = 1;
                ai[j + 1] = 1;
                ai[j + 2] = 0;
                ai[j + 3] = 0;
                break;

            case 68: // 'D'
                ai[j + 0] = 1;
                ai[j + 1] = 1;
                ai[j + 2] = 0;
                ai[j + 3] = 1;
                break;

            case 69: // 'E'
                ai[j + 0] = 1;
                ai[j + 1] = 1;
                ai[j + 2] = 1;
                ai[j + 3] = 0;
                break;

            case 70: // 'F'
                ai[j + 0] = 1;
                ai[j + 1] = 1;
                ai[j + 2] = 1;
                ai[j + 3] = 1;
                break;

            case 58: // ':'
            case 59: // ';'
            case 60: // '<'
            case 61: // '='
            case 62: // '>'
            case 63: // '?'
            case 64: // '@'
            default:
                ai[j + 0] = 0;
                ai[j + 1] = 0;
                ai[j + 2] = 0;
                ai[j + 3] = 0;
                break;
            }
        }

    }

    private void permuteKey(int ai[], int ai1[], int ai2[])
    {
        for(int i = 0; i < ai1.length; i++)
            ai1[i] = ai[ai2[i] - 1];

    }

    private void shiftPermutedKeys(int ai[], int ai1[][], int ai2[][])
    {
        for(int i = 0; i < 28; i++)
        {
            ai1[0][i] = ai[i];
            ai2[0][i] = ai[i + 28];
        }

        shiftKeyLeft(ai1[0], ai1[1], 1);
        shiftKeyLeft(ai2[0], ai2[1], 1);
        shiftKeyLeft(ai1[1], ai1[2], 1);
        shiftKeyLeft(ai2[1], ai2[2], 1);
        shiftKeyLeft(ai1[2], ai1[3], 2);
        shiftKeyLeft(ai2[2], ai2[3], 2);
        shiftKeyLeft(ai1[3], ai1[4], 2);
        shiftKeyLeft(ai2[3], ai2[4], 2);
        shiftKeyLeft(ai1[4], ai1[5], 2);
        shiftKeyLeft(ai2[4], ai2[5], 2);
        shiftKeyLeft(ai1[5], ai1[6], 2);
        shiftKeyLeft(ai2[5], ai2[6], 2);
        shiftKeyLeft(ai1[6], ai1[7], 2);
        shiftKeyLeft(ai2[6], ai2[7], 2);
        shiftKeyLeft(ai1[7], ai1[8], 2);
        shiftKeyLeft(ai2[7], ai2[8], 2);
        shiftKeyLeft(ai1[8], ai1[9], 1);
        shiftKeyLeft(ai2[8], ai2[9], 1);
        shiftKeyLeft(ai1[9], ai1[10], 2);
        shiftKeyLeft(ai2[9], ai2[10], 2);
        shiftKeyLeft(ai1[10], ai1[11], 2);
        shiftKeyLeft(ai2[10], ai2[11], 2);
        shiftKeyLeft(ai1[11], ai1[12], 2);
        shiftKeyLeft(ai2[11], ai2[12], 2);
        shiftKeyLeft(ai1[12], ai1[13], 2);
        shiftKeyLeft(ai2[12], ai2[13], 2);
        shiftKeyLeft(ai1[13], ai1[14], 2);
        shiftKeyLeft(ai2[13], ai2[14], 2);
        shiftKeyLeft(ai1[14], ai1[15], 2);
        shiftKeyLeft(ai2[14], ai2[15], 2);
        shiftKeyLeft(ai1[15], ai1[16], 1);
        shiftKeyLeft(ai2[15], ai2[16], 1);
    }

    private void shiftKeyLeft(int ai[], int ai1[], int i)
    {
        for(int j = 0; j < ai1.length; j++)
        {
            int k;
            if(j + i > ai.length - 1)
                k = (j + i) - ai.length;
            else
                k = j + i;
            ai1[j] = ai[k];
        }

    }

    private void printArray(int ai[])
    {
        for(int i = 0; i < ai.length; i++)
            System.out.print(ai[i] + "");

        System.out.print("\n");
    }

    private String getMatrixString(int ai[], int i)
    {
        String s = "";
        int k = 0;
        for(int j = 0; j < ai.length; j++)
        {
            if(ai[j] < 10)
                s = s + " ";
            s = s + ai[j] + " ";
            if(++k >= i)
            {
                s = s + "\n";
                k = 0;
            }
        }

        System.out.print("\n");
        return s;
    }

    private String getArrayString(int ai[])
    {
        String s = "";
        for(int i = 0; i < ai.length; i++)
            s = s + ai[i];

        return s;
    }

    public Panel getOptionsPanel()
    {
        Panel panel = new Panel();
        Panel panel2 = new Panel(new BorderLayout());
        panel2.add(new Label("64 Bit Key:"), "North");
        Panel panel1 = new Panel(new FlowLayout(0));
        choiceKey01 = new Choice();
        createHexChoices(choiceKey01);
        panel1.add(choiceKey01);
        choiceKey02 = new Choice();
        createHexChoices(choiceKey02);
        panel1.add(choiceKey02);
        choiceKey03 = new Choice();
        createHexChoices(choiceKey03);
        panel1.add(choiceKey03);
        choiceKey04 = new Choice();
        createHexChoices(choiceKey04);
        panel1.add(choiceKey04);
        choiceKey05 = new Choice();
        createHexChoices(choiceKey05);
        panel1.add(choiceKey05);
        choiceKey06 = new Choice();
        createHexChoices(choiceKey06);
        panel1.add(choiceKey06);
        choiceKey07 = new Choice();
        createHexChoices(choiceKey07);
        panel1.add(choiceKey07);
        choiceKey08 = new Choice();
        createHexChoices(choiceKey08);
        panel1.add(choiceKey08);
        panel2.add(panel1, "Center");
        butRandom = new Button("Generate Random Key");
        butRandom.addActionListener(this);
        panel1 = new Panel();
        panel1.add(butRandom);
        panel2.add(panel1, "South");
        panel.setBackground(Color.yellow);
        panel.add(panel2);
        return panel;
    }

    public void actionPerformed(ActionEvent actionevent)
    {
        String s = actionevent.getActionCommand();
        if(s.equals("Generate Random Key"))
            setRandomKey();
    }

    private void setRandomKey()
    {
        choiceKey01.select((int)(Math.random() * (double)choiceKey01.getItemCount()));
        choiceKey02.select((int)(Math.random() * (double)choiceKey02.getItemCount()));
        choiceKey03.select((int)(Math.random() * (double)choiceKey03.getItemCount()));
        choiceKey04.select((int)(Math.random() * (double)choiceKey04.getItemCount()));
        choiceKey05.select((int)(Math.random() * (double)choiceKey05.getItemCount()));
        choiceKey06.select((int)(Math.random() * (double)choiceKey06.getItemCount()));
        choiceKey07.select((int)(Math.random() * (double)choiceKey07.getItemCount()));
        choiceKey08.select((int)(Math.random() * (double)choiceKey08.getItemCount()));
    }

    private void createHexChoices(Choice choice)
    {
        choice.add("00");
        choice.add("01");
        choice.add("02");
        choice.add("03");
        choice.add("04");
        choice.add("05");
        choice.add("06");
        choice.add("07");
        choice.add("08");
        choice.add("09");
        choice.add("0A");
        choice.add("0B");
        choice.add("0C");
        choice.add("0D");
        choice.add("0E");
        choice.add("0F");
        choice.add("10");
        choice.add("11");
        choice.add("12");
        choice.add("13");
        choice.add("14");
        choice.add("15");
        choice.add("16");
        choice.add("17");
        choice.add("18");
        choice.add("19");
        choice.add("1A");
        choice.add("1B");
        choice.add("1C");
        choice.add("1D");
        choice.add("1E");
        choice.add("1F");
        choice.add("20");
        choice.add("21");
        choice.add("22");
        choice.add("23");
        choice.add("24");
        choice.add("25");
        choice.add("26");
        choice.add("27");
        choice.add("28");
        choice.add("29");
        choice.add("2A");
        choice.add("2B");
        choice.add("2C");
        choice.add("2D");
        choice.add("2E");
        choice.add("2F");
        choice.add("30");
        choice.add("31");
        choice.add("32");
        choice.add("33");
        choice.add("34");
        choice.add("35");
        choice.add("36");
        choice.add("37");
        choice.add("38");
        choice.add("39");
        choice.add("3A");
        choice.add("3B");
        choice.add("3C");
        choice.add("3D");
        choice.add("3E");
        choice.add("3F");
        choice.add("40");
        choice.add("41");
        choice.add("42");
        choice.add("43");
        choice.add("44");
        choice.add("45");
        choice.add("46");
        choice.add("47");
        choice.add("48");
        choice.add("49");
        choice.add("4A");
        choice.add("4B");
        choice.add("4C");
        choice.add("4D");
        choice.add("4E");
        choice.add("4F");
        choice.add("50");
        choice.add("51");
        choice.add("52");
        choice.add("53");
        choice.add("54");
        choice.add("55");
        choice.add("56");
        choice.add("57");
        choice.add("58");
        choice.add("59");
        choice.add("5A");
        choice.add("5B");
        choice.add("5C");
        choice.add("5D");
        choice.add("5E");
        choice.add("5F");
        choice.add("60");
        choice.add("61");
        choice.add("62");
        choice.add("63");
        choice.add("64");
        choice.add("65");
        choice.add("66");
        choice.add("67");
        choice.add("68");
        choice.add("69");
        choice.add("6A");
        choice.add("6B");
        choice.add("6C");
        choice.add("6D");
        choice.add("6E");
        choice.add("6F");
        choice.add("70");
        choice.add("71");
        choice.add("72");
        choice.add("73");
        choice.add("74");
        choice.add("75");
        choice.add("76");
        choice.add("77");
        choice.add("78");
        choice.add("79");
        choice.add("7A");
        choice.add("7B");
        choice.add("7C");
        choice.add("7D");
        choice.add("7E");
        choice.add("7F");
        choice.add("80");
        choice.add("81");
        choice.add("82");
        choice.add("83");
        choice.add("84");
        choice.add("85");
        choice.add("86");
        choice.add("87");
        choice.add("88");
        choice.add("89");
        choice.add("8A");
        choice.add("8B");
        choice.add("8C");
        choice.add("8D");
        choice.add("8E");
        choice.add("8F");
        choice.add("90");
        choice.add("91");
        choice.add("92");
        choice.add("93");
        choice.add("94");
        choice.add("95");
        choice.add("96");
        choice.add("97");
        choice.add("98");
        choice.add("99");
        choice.add("9A");
        choice.add("9B");
        choice.add("9C");
        choice.add("9D");
        choice.add("9E");
        choice.add("9F");
        choice.add("A0");
        choice.add("A1");
        choice.add("A2");
        choice.add("A3");
        choice.add("A4");
        choice.add("A5");
        choice.add("A6");
        choice.add("A7");
        choice.add("A8");
        choice.add("A9");
        choice.add("AA");
        choice.add("AB");
        choice.add("AC");
        choice.add("AD");
        choice.add("AE");
        choice.add("AF");
        choice.add("B0");
        choice.add("B1");
        choice.add("B2");
        choice.add("B3");
        choice.add("B4");
        choice.add("B5");
        choice.add("B6");
        choice.add("B7");
        choice.add("B8");
        choice.add("B9");
        choice.add("BA");
        choice.add("BB");
        choice.add("BC");
        choice.add("BD");
        choice.add("BE");
        choice.add("BF");
        choice.add("C0");
        choice.add("C1");
        choice.add("C2");
        choice.add("C3");
        choice.add("C4");
        choice.add("C5");
        choice.add("C6");
        choice.add("C7");
        choice.add("C8");
        choice.add("C9");
        choice.add("CA");
        choice.add("CB");
        choice.add("CC");
        choice.add("CD");
        choice.add("CE");
        choice.add("CF");
        choice.add("D0");
        choice.add("D1");
        choice.add("D2");
        choice.add("D3");
        choice.add("D4");
        choice.add("D5");
        choice.add("D6");
        choice.add("D7");
        choice.add("D8");
        choice.add("D9");
        choice.add("DA");
        choice.add("DB");
        choice.add("DC");
        choice.add("DD");
        choice.add("DE");
        choice.add("DF");
        choice.add("E0");
        choice.add("E1");
        choice.add("E2");
        choice.add("E3");
        choice.add("E4");
        choice.add("E5");
        choice.add("E6");
        choice.add("E7");
        choice.add("E8");
        choice.add("E9");
        choice.add("EA");
        choice.add("EB");
        choice.add("EC");
        choice.add("ED");
        choice.add("EE");
        choice.add("EF");
        choice.add("F0");
        choice.add("F1");
        choice.add("F2");
        choice.add("F3");
        choice.add("F4");
        choice.add("F5");
        choice.add("F6");
        choice.add("F7");
        choice.add("F8");
        choice.add("F9");
        choice.add("FA");
        choice.add("FB");
        choice.add("FC");
        choice.add("FD");
        choice.add("FE");
        choice.add("FF");
    }

    public static final int KEY_SIZE = 64;
    public static final int PERMUTE_KEY_SIZE = 56;
    public static final String BUTRANDOM_LABEL = "Generate Random Key";
    private TextField txtKey;
    private int iKey[];
    private TutorialDisplay txt;
    private Choice choiceKey01;
    private Choice choiceKey02;
    private Choice choiceKey03;
    private Choice choiceKey04;
    private Choice choiceKey05;
    private Choice choiceKey06;
    private Choice choiceKey07;
    private Choice choiceKey08;
    private Button butRandom;
}
